
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity seq_det_tb is
end seq_det_tb;

architecture Behavioral of seq_det_tb is
--
--******************************************
-- Här deklarar ni hur er modul ser ut. I exempelt
-- har modulen seq_det_101 tre insignaler och 
-- en utsignal.
--
--****** Deklarera hur modulen ni vill testa 
--****** ser ut här.
--******************************************
--    component seq_det_101
--        port(
--            rst : in STD_LOGIC;
--            clk : in STD_LOGIC;
--            seq : in STD_LOGIC;
--            d : out STD_LOGIC
--        );
--    end component;

--******************************************
-- Varje signal från modulen som ska testas
-- måste anslutas till en signal i testmodulen.
-- 
--****** Skapa signaler som ni senare kan ansluta
--****** till modulen som ni vill testa här.
--****** En signal för klockan finns redan
--****** deklarerad längre ner.
--******************************************    
--    signal rst_tb, seq_tb, d_tb : STD_LOGIC;
    
--******************************************
-- Modulen som ska testas är ett synkront sekvensnät
-- vi måste därför generera en klocksignal i testmodulen
-- som styr när minneselementen ska uppdateras.
--******************************************    
    signal clk_tb : STD_LOGIC := '0';
    
--******************************************
-- Vi deklarera vilken periodtid vi vill att 
-- klockan ska ha, vilken tid som väljs är
-- inte så noga i den här kursen.
--******************************************
    constant period : TIME := 100ns;
    signal done : STD_LOGIC := '0';
    
begin

--******************************************
-- Här kopplar vi ihop signalerna från modeulen
-- som ska testas med signalerna i testmodulen.
--
--****** Koppla ihop modulen som du deklarerade
--****** tidigare med signalerna i denna 
--****** testmodul.
--******************************************
--device_under_test:seq_det_101 port map(
--    rst => rst_tb,
--    clk => clk_tb,
--    seq => seq_tb,
--    d => d_tb
--);

--******************************************
-- Så här kan man generara en klocksignal under
-- simuleringen. När signalen done=1 så slutar
-- processen att generea klocksignalen.
--******************************************
clock_generator:process
begin
    if(done = '0') then
        wait for period/2;
        clk_tb <= not clk_tb;
    else
        wait;
    end if;
end process;

--******************************************
-- I denna process generar vi alla insignaler till
-- modulen som ska testas, förutom klocksignalen.
-- Först nollställt kretsen därefter genererar
-- vi insignalen 0111010 till modulen.
-- Ändring av insignaler gör vi vid stigande 
-- klockflank.
--
--****** Ändra nedan så ni testar modulen
--****** med "lämpliga" insignaler.
--******************************************
test_bit_generator:process
begin
    rst_tb <= '1';
    wait until rising_edge(clk_tb);
    rst_tb <= '0';
    seq_tb <= '0';

    wait until rising_edge(clk_tb);
    seq_tb <= '1';

    wait until rising_edge(clk_tb);
    seq_tb <= '1';
    
    wait until rising_edge(clk_tb);
    seq_tb <= '1';
        
    wait until rising_edge(clk_tb);
    seq_tb <= '0';
    
    wait until rising_edge(clk_tb);
    seq_tb <= '1';
        
    wait until rising_edge(clk_tb);
    seq_tb <= '0';
    
--******************************************
-- När vi inte ska generar fler insignaler
-- sätter vi done=1 så att klockprocessen 
-- stängs av. Därefter sätter vi den här processen
-- i väntläge (processen kommer då inte 
-- att generera fler signaler).
--******************************************
    wait until rising_edge(clk_tb);
    done <= '1';
    wait;
           
end process;

end Behavioral;
